/*******************************************************************/
/*  CPXDEFS.inc                                                    */
/*  Version 3.0                                                    */
/*                                                                 */
/*  Copyright (c) 1989-1994                                        */
/*  CPLEX Optimization, Inc.                                       */
/*  All Rights Reserved                                            */
/*                                                                 */
/*  Last modified 10 May 1994, REB                                 */
/*******************************************************************/


#ifdef  SYSVAX
#define PROTOTYPE_MIN
#endif

#ifdef  SYSSUN3
#define PROTOTYPE_MIN
#define void      int
#endif

#ifdef  SYSAPOLLO
#define PROTOTYPE_MIN
#endif

#ifdef  SYSAIX
#define PROTOTYPE_MAX
#endif

#ifdef  SYSXENIX
#define PROTOTYPE_MIN
#endif

#ifdef  SYSHP
#define PROTOTYPE_MIN
#endif

#ifdef  SYS386
#define PROTOTYPE_MIN
#endif

#ifdef  SYSHC386
#define PROTOTYPE_MAX
#endif

#ifdef  SYSWAT386
#define PROTOTYPE_MAX
#endif

#ifdef  SYSWATOS2
#define PROTOTYPE_MAX
#endif

#ifdef  SYSSEQUENT
#define PROTOTYPE_MIN
#endif

#ifdef  SYSSVS386
#define PROTOTYPE_MIN
#endif

#ifdef  SYSDFN
#define PROTOTYPE_MIN
#define void      int
#endif

#ifdef  SYSPG860
#define PROTOTYPE_MAX
#endif

#ifdef  SYSU6050
#define PROTOTYPE_MIN
#endif

#ifdef  SYSU6070
#define PROTOTYPE_MIN
#endif

#ifdef  SYSU6065
#define PROTOTYPE_MAX
#endif

#ifdef  SYS1167
pragma on(1167);
#define PROTOTYPE_MIN
#endif

#ifdef  SYSHC1167
pragma on(1167);
#define PROTOTYPE_MAX
#endif

#ifdef  SYS486
pragma on(486);
#define PROTOTYPE_MIN
#endif

#ifdef  SYSHC486
pragma on(486);
#define PROTOTYPE_MAX
#endif

#ifdef  SYSTURBOOS2
#define PROTOTYPE_MAX
#endif

#ifdef  SYSSPARC
#define PROTOTYPE_MIN
#endif

#ifdef  SYSGNUSPARC
#define PROTOTYPE_MAX
#endif

#ifdef  SYSSOLARIS
#define PROTOTYPE_MAX
#endif

#ifdef  SYSGNUSOLARIS
#define PROTOTYPE_MAX
#endif

#ifdef  SYSAVIION
#define PROTOTYPE_MIN
#endif

#ifdef  SYSMIPS
#define PROTOTYPE_MAX
#endif

#ifdef  SYSDECSTATION
#define PROTOTYPE_MAX
#endif

#ifdef  SYSALPHA
#define PROTOTYPE_MIN
#endif

#ifdef  SYSI860
#define PROTOTYPE_MIN
#endif

#ifdef  SYSSILICON
#define PROTOTYPE_MAX
#endif

#ifdef  SYSTITAN
#define PROTOTYPE_MAX
#endif

#ifdef  SYS3090
#define PROTOTYPE_MAX
#endif

#ifdef  SYS2200
#define PROTOTYPE_MAX
#endif

#ifdef  SYSCM5
#define PROTOTYPE_MAX
#endif

#ifdef  SYSCONVEX
#define PROTOTYPE_MIN
#endif

#ifdef  SYSRS6000
#define PROTOTYPE_MAX
#endif

#ifdef  SYSCRAY
#define PROTOTYPE_MIN
#endif

/* It seems necessary to have the include for <stdio.h> after the
   1167 pragma, when that pragma is active. <stdio.h> is include here
   so that the 'FILE' type is defined */

#include <stdio.h>

/* INFBOUND:  Any bound bigger than this is treated as infinity */

#define INFBOUND  1.0E+20

/* Values returned for 'stat' by solution () */

#define  CPX_OPTIMAL                 1
#define  CPX_INFEASIBLE              2
#define  CPX_UNBOUNDED               3
#define  CPX_OBJ_LIM                 4
#define  CPX_IT_LIM_FEAS             5
#define  CPX_IT_LIM_INFEAS           6
#define  CPX_TIME_LIM_FEAS           7
#define  CPX_TIME_LIM_INFEAS         8
#define  CPX_NUM_BEST_FEAS           9
#define  CPX_NUM_BEST_INFEAS        10
#define  CPX_OPTIMAL_INFEAS         11
#define  CPX_ABORT_FEAS             12
#define  CPX_ABORT_INFEAS           13
#define  CPX_ABORT_DUAL_INFEAS      14
#define  CPX_ABORT_PRIM_INFEAS      15
#define  CPX_ABORT_PRIM_DUAL_INFEAS 16
#define  CPX_ABORT_PRIM_DUAL_FEAS   17
#define  CPX_ABORT_CROSSOVER        18

/* Error codes */

#define  CPXERR_NO_MEMORY         1001
#define  CPXERR_NO_PROBLEM        1009
#define  CPXERR_SINGULAR          1002
#define  CPXERR_NO_ROWS           1010
#define  CPXERR_NO_COLS           1011
#define  CPXERR_NOT_LP            1012
#define  CPXERR_SB_INCOMPAT       1013
#define  CPXERR_PRIIND            1014
#define  CPXERR_BOUNDS_INFEAS     1100
#define  CPXERR_PRESLV_INForUNBD  1101
#define  CPXERR_INDEX_RANGE       1200
#define  CPXERR_ARRAY_ENTRY       1201
#define  CPXERR_NOT_OPTIMAL       1202
#define  CPXERR_NET_SMALL         1203
#define  CPXERR_NET_IMBALANCE     1204
#define  CPXERR_BAD_BASIS         1205
#define  CPXERR_NO_FILE           1206
#define  CPXERR_BAD_METHOD        1207
#define  CPXERR_LOCK_TAMPER       1300

/* Pricing options */

#define  CPX_PPRIIND_PARTIAL        -1
#define  CPX_PPRIIND_AUTO            0
#define  CPX_PPRIIND_DEVEX           1
#define  CPX_PPRIIND_STEEP           2
#define  CPX_PPRIIND_STEEPQSTART     3
#define  CPX_PPRIIND_FULL            4

#define  CPX_DPRIIND_AUTO            0
#define  CPX_DPRIIND_FULL            1
#define  CPX_DPRIIND_STEEP           2
#define  CPX_DPRIIND_FULLSTEEP       3
#define  CPX_DPRIIND_STEEPQSTART     4

/* Values returned by getmethod () */

#define  CPXALG_NONE                 0
#define  CPXALG_PRIMAL               1
#define  CPXALG_DUAL                 2
#define  CPXALG_NETWORK              3
#define  CPXALG_BARRIER              4
#define  CPXALG_PIVOT                5

/* Infeasibility Finder return values */

#define  CPXIIS_COMPLETE             1
#define  CPXIIS_PARTIAL              2
#define  CPXIIS_TIME_LIM             3
#define  CPXIIS_SUBPROB              4

/* Infeasibility Finder display values */

#define CPXIIS_TERSE                 1
#define CPXIIS_VERBOSE               2

/* NETOPT optimization status values */

#define CPX_NETOPTIMAL              -1
#define CPX_NETINFEASIBLE           -2
#define CPX_NETUNBOUNDED            -3
#define CPX_NETUNBOUNDED_INF        -4

/* Extra rim vector types used in 'etype'/'rimtype' array */

#define EXTRANROW                    1
#define EXTRARHS                     2
#define EXTRARNG                     3
#define EXTRABDL                     4
#define EXTRABDU                     5

/* Variable types for ctype array */

#define CONTINUOUS                 'C'
#define BINARY                     'B'
#define INTEGER                    'I'

/* Problem Types */

#define  CPXPROB_LP                  0
#define  CPXPROB_MIP                 1
#define  CPXPROB_RELAX               2
#define  CPXPROB_FIX                 3
#define  CPXPROB_SUBLP               4

/* Callback values for wherefrom   */
#define  CPX_CALLBACK_PRIMAL             1
#define  CPX_CALLBACK_DUAL               2
#define  CPX_CALLBACK_NETWORK            3
#define  CPX_CALLBACK_PRIMAL_CROSSOVER   4
#define  CPX_CALLBACK_DUAL_CROSSOVER     5
#define  CPX_CALLBACK_BARRIER            6
/* Be sure to check the MIP values!! */

/* Values for getcallbackinfo function */
#define  CPX_CBINFO_PRIMAL_OBJ           1
#define  CPX_CBINFO_DUAL_OBJ             2
#define  CPX_CBINFO_PRIMAL_INFMEAS       3
#define  CPX_CBINFO_DUAL_INFMEAS         4
#define  CPX_CBINFO_PRIMAL_FEAS          5
#define  CPX_CBINFO_DUAL_FEAS            6
#define  CPX_CBINFO_ITCOUNT              7
#define  CPX_CBINFO_CROSSOVER_SBCNT      8
/* Be sure to check the MIP values */

/* structure types */

struct cpxlp;
struct cpxchannel;
typedef struct cpxlp  *CPXLPptr;

/* I/O channels */

extern struct cpxchannel *cpxerror;      /* errors                 */
extern struct cpxchannel *cpxwarning;    /* warnings               */
extern struct cpxchannel *cpxresults;    /* informational messages */
extern struct cpxchannel *cpxlog;        /* logfile only           */

/* Argument checking enabled */

#ifdef  PROTOTYPE_MAX

/***********************************
 * CPLEX Callable Library Routines *
 ***********************************/

/* dualopt.c */

int
   dualopt (CPXLPptr);

/* netmain.c */

int
   netopt    (CPXLPptr, int *, int *, int *, int *),
   hybnetopt (CPXLPptr, char),
   embwrite  (CPXLPptr, char *);

/* opt.c */

int
   optimize (CPXLPptr);

/* pivotin.c */

int
   pivotin (CPXLPptr, int *, int);

/* twiddle.c */

int
   twiddle (CPXLPptr, int, int *);

/* advance.c */

int
   getbhead     (CPXLPptr, int *, double *),
   binvcol      (CPXLPptr, int, double *),
   binvacol     (CPXLPptr, int, double *),
   binvrow      (CPXLPptr, int, double *),
   binvarow     (CPXLPptr, int, double *),
   ftran        (CPXLPptr, double *),
   btran        (CPXLPptr, double *),
   getijrow     (CPXLPptr, int, int, int *),
   getweight    (CPXLPptr, int, int *, int *, double *, double *,
                 int),
   strongbranch (CPXLPptr, int *, int, double *, double *, int);

/* callback.c */

int
   getcallbackinfo (CPXLPptr, int, int, void *);

/* convert.c */

int
   convert (char *, char *, int);

/* iisfind.c */

int
   displayiis (CPXLPptr, struct cpxchannel *, int),
   findiis    (CPXLPptr, int *, int *),
   getiis     (CPXLPptr, int *, int *, int *, int *, int *,
               int *, int *),
   setiisind  (int, int *, int *),
   iiswrite   (CPXLPptr, char *);

void
   getiisind  (int *);

/* load.c */

void
   unloadprob   (CPXLPptr*),
   freeprob     (CPXLPptr*);

CPXLPptr
   loadprob     (char *, int, int, int, int, double *, double *,
                 char *, int *, int *, int *, double *, double *,
                 double *, double *, int *, int *, int *, int *,
                 int *, double *, char *, char *, char *, char *,
                 char *, char **, char *, char **, char *, char **,
                 char *, int, int, int, int, int, unsigned, unsigned,
                 unsigned),
   loadlp       (char *,int, int, int, double *, double *, char *,
                 int *, int *, int *, double *, double *,double *,
                 double *, int, int, int),
   loadlpwnames (char *,int, int, int, double *, double *, char *,
                 int *, int *, int *, double *, double *,double *,
                 double *, char **, char *, char **, char *, int,
                 int, int, unsigned, unsigned);

/* lpread.c */

int
   lpread  (char *, int *, int *, int *, double **, double **,
            char **, int **, int **, int **, double **, double **,
            double **, char **, char **, char ***, char **,
            char ***, char **, int *, int *, int *, unsigned *,
            unsigned *),
   lpmread (char *, int *, int *, int *, double **, double **,
            char **, int **, int **, int **, double **, double **,
            double **, char **, char **, char ***, char **,
            char ***, char **, int *, int *, int *, unsigned *,
            unsigned *, char **);

/* lpwrite.c */

int
   lpwrite   (CPXLPptr, char *),
   lprewrite (CPXLPptr, char *);

/* mbaserw.c */

int
   mbaseread  (char *, int, int, char **, char **, int *, int *),
   msbaseread (char *, int, int, char **, char **, int *, int *,
               double **, double **),
   mbasewrite (CPXLPptr, char *),
   vecread    (CPXLPptr, char *),
   vecwrite   (CPXLPptr, char *);

/* message.c */

void
   delchannel        (struct cpxchannel **),
   disconnectchannel (struct cpxchannel *),
   flushchannel      (struct cpxchannel *);

int
   cpxmsg            (struct cpxchannel *, char *, ...),
   addfpdest         (struct cpxchannel *, FILE *),
   delfpdest         (struct cpxchannel *, FILE *),
   addfuncdest       (struct cpxchannel *, void *,
                      void (*)(void *, char *)),
   delfuncdest       (struct cpxchannel *, void *,
                      void (*)(void *, char *));

struct cpxchannel *
   addchannel        (void);

/* mpsread.c */

int
   mpsread  (char *, int *, int *, int *, int *, double **,
             double **, char **, int **, int **, int **,
             double **, double **, double **, double **, int **,
             int **, int **, int **, int **, double **,
             char **, char **, char **, char **, char **,
             char ***, char **, char ***, char **, char ***,
             char **, int *, int *, int *, int *, int *,
             unsigned *, unsigned *, unsigned *),
   mpsmread (char *, int *, int *, int *, int *, double **,
             double **, char **, int **, int **, int **,
             double **, double **, double **, double **, int **,
             int **, int **, int **, int **, double **,
             char **, char **, char **, char **, char **,
             char ***, char **, char ***, char **, char ***,
             char **, int *, int *, int *, int *, int *,
             unsigned *, unsigned *, unsigned *, char **,
             int *, int *, char **, int **, int **, double **);

/* mpsrevis.c */

int
   mpsrevise (CPXLPptr, char *);

/* mpswrite.c */

int
   mpswrite   (CPXLPptr, char *),
   mpsrewrite (CPXLPptr, char *),
   dualwrite  (CPXLPptr, char *, double *);

/* oddutil.c */

int
   getspace   (CPXLPptr, int *, int *, int *, unsigned *,
               unsigned *),
   loadbase   (CPXLPptr, int *, int *),
   loadstart  (CPXLPptr, int *, int *, double *, double *,
               double *, double *),
   loaddnorms (CPXLPptr, double *, int *, int),
   loadpnorms (CPXLPptr, double *, double *, int);

/* otherrw.c */

int
   netread        (char *, int *, int *, int *, double **, double **,
                   char **, int **, int **, int **, double **,
                   double **, double **, int *, int *, int *),
   readpar        (char *, int *, int *, int *, double **, double **,
                   char **, int **, int **, int **, double **,
                   double **, double **, int *, int *, int *,
                   char **),
   perwrite       (CPXLPptr, char *, double);

/* preutil.c */

int
   preslvwrite (CPXLPptr, char *);

/* quality.c */

double
   checkax  (CPXLPptr, int *, int),
   checkpib (CPXLPptr, int *, int);

/* query.c */

int
   getprobname (CPXLPptr, char *),
   getmac      (CPXLPptr),
   getmar      (CPXLPptr),
   getmat      (CPXLPptr),
   getmae      (CPXLPptr),
   getnr       (CPXLPptr),
   getnrnz     (CPXLPptr),
   getenz      (CPXLPptr),
   getobjsen   (CPXLPptr),
   getobj      (CPXLPptr, double *, int, int),
   getrhs      (CPXLPptr, double *, int, int),
   getsense    (CPXLPptr, char *, int, int),
   getcols     (CPXLPptr, int *, int *, int *, double *, int,
                int *, int, int),
   getrows     (CPXLPptr, int *, int *, int *, double *, int,
                int *, int, int),
   getnrows    (CPXLPptr, int *, int *, int *, double *, int,
                int *, int, int),
   getextra    (CPXLPptr, int *, int *, int *, double *, int,
                int *, int, int),
   getbdl      (CPXLPptr, double *, int, int),
   getbdu      (CPXLPptr, double *, int, int),
   getrngval   (CPXLPptr, double *, int, int),
   getnrind    (CPXLPptr, int *, int, int),
   getetype    (CPXLPptr, int *, int, int),
   getdataname (CPXLPptr, char *),
   getobjname  (CPXLPptr, char *),
   getrhsname  (CPXLPptr, char *),
   getrngname  (CPXLPptr, char *),
   getbndname  (CPXLPptr, char *),
   getcname    (CPXLPptr, char **, char *, int, int *, int,
                int),
   getrname    (CPXLPptr, char **, char *, int, int *, int,
                int),
   getename    (CPXLPptr, char **, char *, int, int *, int,
                int),
   getmacsz    (CPXLPptr),
   getmarsz    (CPXLPptr),
   getmatsz    (CPXLPptr),
   getmaesz    (CPXLPptr),
   getenzsz    (CPXLPptr),
   getbase     (CPXLPptr, int *, int *),
   getdnorms   (CPXLPptr, double *, int *, int *),
   getpnorms   (CPXLPptr, double *, double *, int *),
   getitc      (CPXLPptr),
   getitci     (CPXLPptr),
   getgrad     (CPXLPptr, int, int *, double *),
   getcoef     (CPXLPptr, int, int, double *),
   getsbcnt    (CPXLPptr),
   getijdiv    (CPXLPptr, int *, int *);

unsigned
   getcstorsz  (CPXLPptr),
   getrstorsz  (CPXLPptr),
   getestorsz  (CPXLPptr);

double
   getkappa    (CPXLPptr);

/* savread.c */

int
   savread  (char *, int *, int *, int *, int *, double **,
             double **, char **, int **, int **, int **,
             double **, double **, double **, double **, int **,
             int **, int **, int **, int **, double **,
             char **, char **, char **, char **, char **,
             char ***, char **, char ***, char **, char ***,
             char **, int *, int *, int *, int *, int *,
             unsigned *, unsigned *, unsigned *, int **, int **),
   savmread (char *, int *, int *, int *, int *, double **,
             double **, char **, int **, int **, int **,
             double **, double **, double **, double **, int **,
             int **, int **, int **, int **, double **,
             char **, char **, char **, char **, char **,
             char ***, char **, char ***, char **, char ***,
             char **, int *, int *, int *, int *, int *,
             unsigned *, unsigned *, unsigned *, char **,
             int *, int *, char **, int **, int **, int **,
             double **, int **, int **);

/* savwrite.c */

int
   savwrite (CPXLPptr, char *);

/* sensit.c */

int
   rhssa  (CPXLPptr, int, int, double *, double *),
   objsa  (CPXLPptr, int, int, double *, double *);

/* solution.c */

int
   solution  (CPXLPptr, int *, double *, double *, double *,
              double *, double *),
   getmethod (CPXLPptr),
   getobjval (CPXLPptr, double *),
   getx      (CPXLPptr, double *, int, int),
   getpi     (CPXLPptr, double *, int, int),
   getslack  (CPXLPptr, double *, int, int),
   getdj     (CPXLPptr, double *, int, int);

/* solwrite.c */

int
   txtsolwrite (CPXLPptr, char *),
   binsolwrite (CPXLPptr, char *),
   solwrite    (CPXLPptr, void (*) (CPXLPptr),
                void (*) (void), void (*) (void),
                void (*) (char, int, char *, char *, double,
                          double, double, double, double),
                void (*) (void));

/* uchange.c */

void
   chgobjsen  (CPXLPptr, int);

int
   addrows    (CPXLPptr, int, int, int, double *, char *,
               int *, int *, double *, char **, char **),
   faddrows   (CPXLPptr, int, int, int, double *, char *,
               int *, int *, double *, char **, char **),
   delrows    (CPXLPptr, int, int),
   delsetrows (CPXLPptr, int *),
   addcols    (CPXLPptr, int, int, double *, int *, int *,
               double *, double *, double *, char **),
   delcols    (CPXLPptr, int, int),
   delsetcols (CPXLPptr, int *),
   chgcoef    (CPXLPptr, int, int, double),
   chgbds     (CPXLPptr, int, int *, char *, double *),
   chgobj     (CPXLPptr, int, int *, double *),
   chgrhs     (CPXLPptr, int, int *, double *),
   chgsense   (CPXLPptr, int, int *, char *);

/* nchange.c */

int
   chgfromnrow (CPXLPptr, int, int *, char *, double *, int *),
   chgtonrow   (CPXLPptr, int, int *, int *),
   chgncoef    (CPXLPptr, int, int, double);

/* uset.c */

void
   getaggfill  (int *),
   getitlim    (int *),
   getreinv    (int *),
   getmlim     (int *),
   getnlim     (int *),
   getnzlim    (int *),
   getelim     (int *),
   getenzlim   (int *),
   getedlimu   (int *),
   getepopt    (double *),
   getepper    (double *),
   gettilim    (double *),
   getperind   (int *),
   getlogfile  (FILE **),
   getitfoind  (int *),
   getppriind  (int *),
   getdpriind  (int *),
   getadvind   (int *),
   getobjulim  (double *),
   getobjllim  (double *),
   getsinglim  (int *),
   getsingtol  (double *),
   geteprhs    (double *),
   getepmrk    (double *),
   getcraind   (int *),
   getscaind   (int *),
   getbasintv  (int *),
   getpreind   (int *),
   getaggind   (int *),
   getdepind   (int *),
   getxxxind   (int *),
   getfastmip  (int *),
   getrfilemul (double *),
   getcfilemul (double *),
   getnetfind  (int *),
   getlpcallbackfunc (int (**)(CPXLPptr, int));

int
   setaggfill  (int, int *, int *),
   setitlim    (int, int *, int *),
   setreinv    (int, int *, int *),
   setmlim     (int, int *, int *),
   setnlim     (int, int *, int *),
   setnzlim    (int, int *, int *),
   setelim     (int, int *, int *),
   setenzlim   (int, int *, int *),
   setedlimu   (int, int *, int *),
   setepopt    (double, double *, double *),
   setepper    (double, double *, double *),
   settilim    (double, double *, double *),
   setperind   (int),
   setscr_ind  (int),
   setlogfile  (FILE *),
   setitfoind  (int, int *, int *),
   setppriind  (int, int *, int *),
   setdpriind  (int, int *, int *),
   setadvind   (int),
   setobjulim  (double, double *, double *),
   setobjllim  (double, double *, double *),
   setsinglim  (int, int *, int *),
   setsingtol  (double, double *, double *),
   seteprhs    (double, double *, double *),
   setepmrk    (double, double *, double *),
   setcraind   (int, int *, int *),
   setscaind   (int, int *, int *),
   setbasintv  (int, int *, int *),
   setpreind   (int),
   setdepind   (int),
   setaggind   (int),
   setxxxind   (int),
   setfastmip  (int),
   setrfilemul (double, double *, double *),
   setcfilemul (double, double *, double *),
   setdefaults (void),
   setnetfind  (int, int *, int *),
   setlpcallbackfunc (int (*)(CPXLPptr, int));

#endif /* END PROTOTYPE_MAX */

#ifdef  PROTOTYPE_MIN

/***********************************
 * CPLEX Callable Library Routines *
 ***********************************/

/* dualopt.c */

int
   dualopt ();

/* netmain.c */

int
   netopt    (),
   hybnetopt (),
   embwrite  ();

/* opt.c */

int
   optimize ();

/* pivotin.c */

int
   pivotin ();

/* twiddle.c */

int
   twiddle ();

/* advance.c */

int
   getbhead     (),
   binvcol      (),
   binvacol     (),
   binvrow      (),
   binvarow     (),
   ftran        (),
   btran        (),
   getijrow     (),
   getweight    (),
   strongbranch ();

/* callback.c */

int
   getcallbackinfo ();

/* convert.c */

int
   convert ();

/* iisfind.c */

int
   displayiis (),
   findiis    (),
   getiis     (),
   setiisind  (),
   iiswrite   ();

void
   getiisind  ();

/* load.c */

void
   unloadprob   (),
   freeprob     ();

CPXLPptr
   loadprob     (),
   loadlp       (),
   loadlpwnames ();

/* lpread.c */

int
   lpread  (),
   lpmread ();

/* lpwrite.c */

int
   lpwrite   (),
   lprewrite ();

/* mbaserw.c */

int
   mbaseread  (),
   msbaseread (),
   mbasewrite (),
   vecread    (),
   vecwrite   ();

/* message.c */

void
   delchannel        (),
   disconnectchannel (),
   flushchannel      ();

int
   cpxmsg            (),
   addfpdest         (),
   delfpdest         (),
   addfuncdest       (),
   delfuncdest       ();

struct cpxchannel *
   addchannel        ();

/* mpsread.c */

int
   mpsread  (),
   mpsmread ();

/* mpsrevis.c */

int
   mpsrevise ();

/* mpswrite.c */

int
   mpswrite   (),
   mpsrewrite (),
   dualwrite  ();

/* oddutil.c */

int
   getspace   (),
   loadbase   (),
   loadstart  (),
   loaddnorms (),
   loadpnorms ();

/* otherrw.c */

int
   netread        (),
   readpar        (),
   perwrite       ();

/* preutil.c */

int
   preslvwrite ();

/* quality.c */

double
   checkax  (),
   checkpib ();

/* query.c */

int
   getprobname (),
   getmac      (),
   getmar      (),
   getmat      (),
   getmae      (),
   getnr       (),
   getnrnz     (),
   getenz      (),
   getobjsen   (),
   getobj      (),
   getrhs      (),
   getsense    (),
   getcols     (),
   getrows     (),
   getnrows    (),
   getextra    (),
   getbdl      (),
   getbdu      (),
   getrngval   (),
   getnrind    (),
   getetype    (),
   getdataname (),
   getobjname  (),
   getrhsname  (),
   getrngname  (),
   getbndname  (),
   getcname    (),
   getrname    (),
   getename    (),
   getmacsz    (),
   getmarsz    (),
   getmatsz    (),
   getmaesz    (),
   getenzsz    (),
   getbase     (),
   getdnorms   (),
   getpnorms   (),
   getitc      (),
   getitci     (),
   getgrad     (),
   getcoef     (),
   getsbcnt    (),
   getijdiv    ();

unsigned
   getcstorsz  (),
   getrstorsz  (),
   getestorsz  ();

double
   getkappa    ();

/* savread.c */

int
   savread  (),
   savmread ();

/* savwrite.c */

int
   savwrite ();

/* sensit.c */

int
   rhssa  (),
   objsa  ();

/* solution.c */

int
   solution  (),
   getmethod (),
   getobjval (),
   getx      (),
   getpi     (),
   getslack  (),
   getdj     ();

/* solwrite.c */

int
   txtsolwrite (),
   binsolwrite (),
   solwrite    ();

/* uchange.c */

void
   chgobjsen  ();

int
   addrows    (),
   faddrows   (),
   delrows    (),
   delsetrows (),
   addcols    (),
   delcols    (),
   delsetcols (),
   chgcoef    (),
   chgbds     (),
   chgobj     (),
   chgrhs     (),
   chgsense   ();

/* nchange.c */

int
   chgfromnrow (),
   chgtonrow   (),
   chgncoef    ();

/* uset.c */

void
   getaggfill  (),
   getitlim    (),
   getreinv    (),
   getmlim     (),
   getnlim     (),
   getnzlim    (),
   getelim     (),
   getenzlim   (),
   getedlimu   (),
   getepopt    (),
   getepper    (),
   gettilim    (),
   getperind   (),
   getlogfile  (),
   getitfoind  (),
   getppriind  (),
   getdpriind  (),
   getadvind   (),
   getobjulim  (),
   getobjllim  (),
   getsinglim  (),
   getsingtol  (),
   geteprhs    (),
   getepmrk    (),
   getcraind   (),
   getscaind   (),
   getbasintv  (),
   getpreind   (),
   getaggind   (),
   getdepind   (),
   getxxxind   (),
   getfastmip  (),
   getrfilemul (),
   getcfilemul (),
   getnetfind  (),
   getlpcallbackfunc ();

int
   setaggfill  (),
   setitlim    (),
   setreinv    (),
   setmlim     (),
   setnlim     (),
   setnzlim    (),
   setelim     (),
   setenzlim   (),
   setedlimu   (),
   setepopt    (),
   setepper    (),
   settilim    (),
   setperind   (),
   setscr_ind  (),
   setlogfile  (),
   setitfoind  (),
   setppriind  (),
   setdpriind  (),
   setadvind   (),
   setobjulim  (),
   setobjllim  (),
   setsinglim  (),
   setsingtol  (),
   seteprhs    (),
   setepmrk    (),
   setcraind   (),
   setscaind   (),
   setbasintv  (),
   setpreind   (),
   setdepind   (),
   setaggind   (),
   setxxxind   (),
   setfastmip  (),
   setrfilemul (),
   setcfilemul (),
   setdefaults (),
   setnetfind  (),
   setlpcallbackfunc ();

#endif /* END PROTOTYPE_MIN */

/*******************************************************************/
/*  BARDEFS.inc                                                    */
/*  Version 3.0                                                    */
/*                                                                 */
/*  Copyright (c) 1993, 1994                                       */
/*  CPLEX Optimization, Inc.                                       */
/*  All Rights Reserved                                            */
/*                                                                 */
/*  Last modified 29 March 1994, IJL                               */
/*******************************************************************/


/* Has defines for external functions and constants.
   Is equivalent to things that are in cpxdefs.inc */

#define CPX_PRIM_INFEAS                 32
#define CPX_DUAL_INFEAS                 33
#define CPX_PRIM_DUAL_INFEAS            34
#define CPX_PRIM_OBJ_LIM                35
#define CPX_DUAL_OBJ_LIM                36
#define CPX_OPTIMAL_FACE_UNBOUNDED      37
#define CPX_NUM_BEST_PRIM_DUAL_FEAS     38
#define CPX_NUM_BEST_PRIM_INFEAS        39
#define CPX_NUM_BEST_DUAL_INFEAS        40
#define CPX_NUM_BEST_PRIM_DUAL_INFEAS   41

#define CPXERR_BARRIER_NUMERICAL      4001


#ifdef PROTOTYPE_MAX

/* hybopt.c   */

int
   baropt    (CPXLPptr),
   hybbaropt (CPXLPptr);

/* baruset.c  */

void
   getbarfactor   (int *),
   getbaritlim    (int *),
   getbarorder    (int *),
   getbarpstart   (double *),
   getbardstart   (double *),
   getbarcolnz    (int *),
   getbarrowsden  (int *),
   getbarobjrng   (double *),
   getbarcgmeth   (int *),
   getbarepcomp   (double *),
   getbargrowth   (double *),
   getbardisplay  (int *),
   getbarvarup    (double *);

int
   setbarfactor   (int, int *, int *),
   setbaritlim    (int, int *, int *),
   setbarorder    (int, int *, int *),
   setbarpstart   (double, double *, double *),
   setbardstart   (double, double *, double *),
   setbarcolnz    (int, int *, int *),
   setbarrowsden  (int, int *, int *),
   setbarobjrng   (double, double *, double *),
   setbarcgmeth   (int, int *, int *),
   setbarepcomp   (double, double *, double *),
   setbargrowth   (double, double *, double *),
   setbardisplay  (int, int *, int *),
   setbarvarup    (double, double *, double *);

#endif

#ifdef  PROTOTYPE_MIN

/* hybopt.c */

int
   baropt    (),
   hybbaropt ();

/* baruset.c  */

void
   getbarfactor   (),
   getbaritlim    (),
   getbarorder    (),
   getbarpstart   (),
   getbardstart   (),
   getbarcolnz    (),
   getbarrowsden  (),
   getbarobjrng   (),
   getbarcgmeth   (),
   getbarepcomp   (),
   getbargrowth   (),
   getbardisplay  (),
   getbarvarup    ();

int
   setbarfactor   (),
   setbaritlim    (),
   setbarorder    (),
   setbarpstart   (),
   setbardstart   (),
   setbarcolnz    (),
   setbarrowsden  (),
   setbarobjrng   (),
   setbarcgmeth   (),
   setbarepcomp   (),
   setbargrowth   (),
   setbardisplay  (),
   setbarvarup    ();

#endif

/*******************************************************************/
/*  MIPDEFS.inc                                                    */
/*  Version 3.0                                                    */
/*                                                                 */
/*  Copyright (c) 1989-1994                                        */
/*  CPLEX Optimization, Inc.                                       */
/*  All Rights Reserved                                            */
/*                                                                 */
/*  Last modified 25 April 1994, MCF                               */
/*******************************************************************/


/* MIP error codes */

#define  CPXERR_BOUNDS_INT       3002
#define  CPXERR_NOT_MIP          3003
#define  CPXERR_SOS_BDS          3004

/* Values for sostype */

#define SOS1                      '1'
#define SOS2                      '2'

/* MIP Problem status codes */

#define  CPXMIP_OPTIMAL           101
#define  CPXMIP_OPTIMAL_TOL       102
#define  CPXMIP_INFEASIBLE        103
#define  CPXMIP_SOL_LIM           104
#define  CPXMIP_NODE_LIM_FEAS     105
#define  CPXMIP_NODE_LIM_INFEAS   106
#define  CPXMIP_TIME_LIM_FEAS     107
#define  CPXMIP_TIME_LIM_INFEAS   108
#define  CPXMIP_FAIL_FEAS         109
#define  CPXMIP_FAIL_INFEAS       110
#define  CPXMIP_MEM_LIM_FEAS      111
#define  CPXMIP_MEM_LIM_INFEAS    112
#define  CPXMIP_ABORT_FEAS        113
#define  CPXMIP_ABORT_INFEAS      114
#define  CPXMIP_OPTIMAL_INFEAS    115
#define  CPXMIP_FAIL_FEAS_NO_TREE 116

/* Callback values for wherefrom   */
#define  CPX_CALLBACK_MIP         101
/* Be sure to check the LP values!! */

/* Values for getcallbackinfo function */
#define  CPX_CBINFO_BEST_INTEGER         101
#define  CPX_CBINFO_BEST_REMAINING       102
#define  CPX_CBINFO_NODE_COUNT           103
#define  CPX_CBINFO_NODES_LEFT           104
#define  CPX_CBINFO_MIP_ITERATIONS       105
/* Be sure to check the LP values!! */


/* Function definitions */

#ifdef   PROTOTYPE_MAX

/* mipload.c */

CPXLPptr
   loadmprob (char *, int, int, int, int, double *, double *,
              char *, int *, int *, int *, double *, double *,
              double *, double *, int *, int *, int *, int *,
              int *, double *, char *, char *, char *, char *,
              char *, char **, char *, char **, char *, char **,
              char *, int, int, int, int, int, unsigned, unsigned,
              unsigned, char *);

int
   loadctype (CPXLPptr, char *),
   loadsos   (CPXLPptr, int, int, char *, int *, int *, int *,
              double *),
   loadorder (CPXLPptr, int, int *, int *, int *);

/* mipopt.c */

int
   mipoptimize (CPXLPptr);

/* mipordrd.c */

int
   ordread (char *, int, char **, int *, int *, int *, int *);

/* mipquery.c */

int
   getctype    (CPXLPptr, char *, int, int),
   getprtype   (CPXLPptr),
   getbinc     (CPXLPptr),
   getintc     (CPXLPptr),
   getitcm     (CPXLPptr),
   getbobjval  (CPXLPptr, double *),
   getcutoff   (CPXLPptr, double *),
   getndc      (CPXLPptr),
   getndleft   (CPXLPptr),
   getndint    (CPXLPptr),
   getgclqc    (CPXLPptr),
   getclqc     (CPXLPptr),
   getcovc     (CPXLPptr);

/* mipsol.c */

int
   getstat    (CPXLPptr),
   getmx      (CPXLPptr, double *, int, int),
   getmslack  (CPXLPptr, double *, int, int),
   getmobjval (CPXLPptr, double *);

/* mipsosrw.c */

int
   sosread    (char *, int, char **, int *, int *, char **, int **,
               int **, int **, double **),
   soswrite   (CPXLPptr, char *);

/* miptrerw.c */

int
   treeread  (CPXLPptr, char *),
   treewrite (CPXLPptr, char *);

/* mipuchg.c */

int
   chgctype   (CPXLPptr, int, int *, char *),
   chgprtype  (CPXLPptr, int);

/* mipuset.c */

void
   getbttol     (double *),
   getbrdir     (int *),
   getcliques   (int *),
   getcoeredind (int *),
   getcovers    (int *),
   getcutlo     (double *),
   getcutup     (double *),
   getepagap    (double *),
   getepgap     (double *),
   getepint     (double *),
   getheuristic (int *),
   getmifo      (int *),
   getmint      (int *),
   getmipcallbackfunc (int (**)(CPXLPptr, int)),
   getmslim     (int *),
   getndlim     (int *),
   getndsel     (int *),
   getobjdif    (double *),
   getordind    (int *),
   getrcfixind  (int *),
   getrelobjdif (double *),
   getsosind    (int *),
   getsosminsz  (int *),
   getsubalg    (int *),
   getstartalg  (int *),
   gettrelim    (double *),
   getvarsel    (int *);

int
   setbttol     (double, double *, double *),
   setbrdir     (int, int *, int *),
   setcliques   (int, int *, int *),
   setcoeredind (int),
   setcovers    (int, int *, int *),
   setcutlo     (double, double *, double *),
   setcutup     (double, double *, double *),
   setepagap    (double, double *, double *),
   setepgap     (double, double *, double *),
   setepint     (double, double *, double *),
   setheuristic (int, int *, int *),
   setmifo      (int, int *, int *),
   setmint      (int, int *, int *),
   setmipcallbackfunc (int (*)(CPXLPptr, int)),
   setmslim     (int, int *, int *),
   setndlim     (int, int *, int *),
   setndsel     (int, int *, int *),
   setobjdif    (double, double *, double *),
   setordind    (int),
   setrcfixind  (int),
   setrelobjdif (double, double *, double *),
   setsosind    (int),
   setsosminsz  (int, int *, int *),
   setsubalg    (int, int *, int *),
   setstartalg  (int, int *, int *),
   settrelim    (double, double *, double *),
   setvarsel    (int, int *, int *);


#endif /* END PROTOTYPE_MAX */

#ifdef  PROTOTYPE_MIN

/***********************************
 * CPLEX Callable Library Routines *
 ***********************************/

/* mipload.c */

CPXLPptr
   loadmprob ();

int
   loadsos(),
   loadorder ();

/* mipopt.c */

int
   mipoptimize ();

/* mipordrd.c */

int
   ordread ();

/* mipquery.c */

int
   getctype    (),
   getprtype   (),
   getbinc     (),
   getintc     (),
   getitcm     (),
   getbobjval  (),
   getcutoff   (),
   getndc      (),
   getndleft   (),
   getndint    (),
   getgclqc    (),
   getclqc     (),
   getcovc     ();

/* mipsol.c */

int
   getstat    (),
   getmx      (),
   getmslack  (),
   getmobjval ();

/* mipsosrw.c */

int
   sosread      (),
   soswrite     ();

/* miptrerw.c */

int
   treeread  (),
   treewrite ();

/* mipuchg.c */

int
   chgctype  (),
   chgprtype ();

/* mipuset.c */

void
   getbttol     (),
   getbrdir     (),
   getcliques   (),
   getcoeredind (),
   getcovers    (),
   getcutlo     (),
   getcutup     (),
   getepagap    (),
   getepgap     (),
   getepint     (),
   getheuristic (),
   getmifo      (),
   getmint      (),
   getmipcallbackfunc (),
   getmslim     (),
   getndlim     (),
   getndsel     (),
   getobjdif    (),
   getordind    (),
   getrcfixind  (),
   getrelobjdif (),
   getsosind    (),
   getsosminsz  (),
   getsubalg    (),
   getstartalg  (),
   gettrelim    (),
   getvarsel    ();

int
   setbttol     (),
   setbrdir     (),
   setcliques   (),
   setcoeredind (),
   setcovers    (),
   setcutlo     (),
   setcutup     (),
   setepagap    (),
   setepgap     (),
   setepint     (),
   setheuristic (),
   setmifo      (),
   setmint      (),
   setmipcallbackfunc (),
   setmslim     (),
   setndlim     (),
   setndsel     (),
   setobjdif    (),
   setordind    (),
   setrcfixind  (),
   setrelobjdif (),
   setsosind    (),
   setsosminsz  (),
   setsubalg    (),
   setstartalg  (),
   settrelim    (),
   setvarsel    ();

#endif /* END PROTOTYPE_MIN */
