#
# Concerning the html links of the reference manual:
# Must: - Function, variables etc in 'ABACUS-style'
#       - if functions are overloaded, then they have to appear 
#         a) successively
#         b) in same order in header and in implementation
#
BEGIN {
  Headline = "";
  masterIndex = "";
  indexEntry    = "";
  text = "";
  header = "";
  Function= "";
  Return = "";
  arguments = "";

  saveText = 0;
  saveHeader = 0;
  saveFunction = 0;
  saveReturn = 0;
  saveArguments = 0;

  module="ABA";
  moduleCode=module "_";
  moduleTex=module "?";
  className="";
  longFunc=0;
  lastFuncName="";
  lastHtmlLabel="";
  overloadCounter=1;
}

{

  if (saveText + saveHeader + saveFunction + saveReturn + saveArguments > 1) {
    print "makeman: error in or before line " NR > "/dev/tty";
    exit 1;
  }
  if ($1 == "@q" && $2 == "m") {
    if ($3 == "i") {
      masterIndex = $4;
      indexEntry = $4;
   }
    else if ($3 == "f" || $3 == "v" || $3 == "c" || $3 == "u" || $3 == "p") {
      if ($3 == "c") {
	Headline = "\n\subsection{";
	masterIndex = $4;
      }
      else if ($3 == "f" || $3 == "v") Headline = "\n\subsubsection{";
      else if ($3 == "u") Headline = "\subsubsection{enum ";
      else if ($3 == "p") Headline = "\subsubsection{";
      for (i = 4; i < NF; i++) {
	Headline = Headline $i;
	if (i < NF - 1) Headline = Headline " ";
      }
      if ($3 == "v") Headline = Headline " ({\\tt virtual})";
      Headline = Headline "}";
      saveText = 1;

      for (i = 4; i < NF; i++) {
	if (i == 4) indexEntry = $i;
	else indexEntry = indexEntry " " $i;
      }
      
      # build label
      shortClass=substr(masterIndex,5,length(masterIndex)-4);
      htmlLabel= moduleTex shortClass  "::";
      if($3=="u")
	htmlLabel=htmlLabel $4 ;
      else if ($3=="p") {
	pp=index($4,"\_");
	htmlLabel=htmlLabel substr($4,1,pp-1) "?" ;
      }else if($3=="v"||$3=="f"){
	if(pp=index($4,"\_")){
	  if(pp!=1){
	    print "makeman: error in or before line " NR > "/dev/tty";
	    exit 1;	 
	  }	    
	  htmlLabel= htmlLabel "?" substr($4,3,length($4)-2);
	}
	else if($4=="Constructor"|| ($4=="Copy" && $5 == "Constructor"))
	  htmlLabel=htmlLabel shortClass;
	else if ($4=="Destructor")
	  htmlLabel=htmlLabel "Dest" shortClass;
	else if ($4=="Assignment" && $5=="Operator")
	  htmlLabel=htmlLabel "operator=";
	else if ($4=="Comparison" && $5=="Operator")
	  htmlLabel=htmlLabel "operator==";
	else if (($4=="Output" && $5=="Operator") || $4 == "Manipulator")
	  htmlLabel=htmlLabel "operator<<";
	else if ($4=="Subscript" && $5=="Operator")
	  htmlLabel=htmlLabel "operator[]";
	else if ($4=="Not-Equal" && $5=="Operator")
	  htmlLabel=htmlLabel "operator!=";
	else if ($5==Operator) {
	  print "makeman: error in or before line " NR > "/dev/tty";
	  print "Unknown Operator";
	  exit 1;  
	}else
	  htmlLabel=htmlLabel $4;



	if(htmlLabel==lastHtmlLabel) {
	  htmlLabel=lastHtmlLabel overloadCounter;
	  overloadCounter++;
	}else {
	  overloadCounter=1;
	  lastHtmlLabel=htmlLabel;
	}
      }
    }

    if($3 == "o") {
      if(saveHeader==0){
	print "makeman: error in or before line " NR > "/dev/tty";
	exit 1;  
      }	
      overloadCounter=1;
      lastFuncName="";
    }else if ($3 == "s") {
      supressPrivate=0;
    }
    else if ($3 == "b") {
      if ($4 == "t")       saveText      = 1;
      else if ($4 == "h")  saveHeader    = 1;
      else if ($4 == "f")  saveFunction  = 1;
      else if ($4 == "r")  saveReturn    = 1;
      else if ($4 == "a")  saveArguments = 1;
    }
    else if ($3 == "e" || $3 == "d") {
      if ($4 == "t")       saveText   = 0;
      else if ($4 == "h")  saveHeader       = 0;
      else if ($4 == "f")  saveFunction     = 0;
      else if ($4 == "r")  saveReturn       = 0;
      else if ($4 == "a")  saveArguments    = 0;
    }
    
    if ($3 == "d" && $4 == "h" || \
	$3 == "e" && $4 == "f" || \
	$3 == "d" && $4 == "t" ) {
      if ($4 == "h") {
	printf ("%s\\index{%s@{\\tt %s}}\n\n", Headline, indexEntry,indexEntry);
	print "\\label{" moduleTex className "}";
#	print "#" moduleTex className "#">> "allLabel";
	print text;
	print "";
	header= header "\end{tabbing}" "\n" "}" "\n";
	print header;
	saveHeader=0;
	className="";
	header="";
	print "";
	text   = "";
	header = "";
	Headline = "";
	indexEntry    = "";
      }
      else if ($4 == "f") {
	printf ("%s\\index{%s@{\\tt %s}!%s@{\\tt %s}}\n\n", Headline, masterIndex, masterIndex, indexEntry, indexEntry);
	print "\\label{" htmlLabel "}";
#	print "#" htmlLabel "#">> "allLabel";
	print text;
	print "\\begin{verbatim}";
	print Function;
	print "\\end{verbatim}"
	print Return;
	print arguments;
	text      =    "";
	Function  = "";
	Return    = "";
	arguments = "";
	Headline = "";
	indexEntry    = "";
      }
      else if ($4 == "t") {
	printf ("%s\\index{%s@{\\tt %s}!%s@{\\tt %s}}\n\n", Headline, masterIndex, masterIndex, indexEntry,indexEntry);
	print "\\label{" htmlLabel "}";
#	print "#" htmlLabel "#" >> "allLabel";
	print text;
	print "";
	text = "";
	Headline = "";
	indexEntry    = "";
      }
    }
  }
  else if ($1 == "@#") {
  }
  else if (saveText) text   = text "\n" $0;
  else if (saveHeader) {
    if(header=="") {
      header="{\\ttfamily" "\n";
      header= header "\\begin{tabbing}" "\n";
      header= header "XYZ\=XYZ\=\kill" "\n";
    }

    for(i=1;i<length($0);i++) {
      c=substr($0,i,1);
      if(c!=" "&&c!="\t")
	break;
    }
    tmp=substr($0,i,length($0)-i+1);

    for(i=0;i<3;i++){
      tmptmp=tmp;
      tmp="";
      if(i==0)
	c="{";
      else if(i==1)
	c="}";
      else
	c="~";
      while(1){
	pp=index(tmptmp,c);
	if(pp) {
	  tmp=tmp substr(tmptmp,1,pp-1);
	  if(i<2)
	    tmp=tmp "\\" c;
	  else
	    tmp=tmp "\~\/";

	  if(pp<length(tmptmp))
	    tmptmp= substr(tmptmp,pp+1,length(tmptmp)-pp)
	  else
	    break;
	}else {
	  tmp=tmp tmptmp;
	  break;
	}
      }
    }

    loop=0;
    while(1){
      sv=sa=sf=se=0;
      supress=0;
      sa=index(tmp,moduleCode);
      if(sa) {	
	ea=sa+4;
	c=substr(tmp,ea,1);
	if(length(tmp)>=2)
	  cc=substr(tmp,ea,2);
	else
	  cc="";
	while((c>="A"&&c<="Z")||c=="::") {
	  if(c=="::")
	    ea=ea+2;
	  else
	    ea++;
	  c=substr(tmp,ea,1);
	} 
	ea--;
	if(className=="") {
	  className=substr(tmp,sa+4,ea-sa-3);
	  supress=1;
	}else if(className==substr(tmp,sa+4,ea-sa-3)){
	  supress=1;
	}
      }

      if(!longFunc) {
	se=index(tmp,"enum ");
	if(se) {	
	  se=se+5;
	  c=substr(tmp,se,1);
	  while(c==" "){
	    se++;
	    c=substr(tmp,se,1);
	  }
	  ee=se+1;
	  while(c>="A"&&c<="Z") {
	    ee++;
	    c=substr(tmp,ee,1);
	  } 
	  ee--;
	}
	
	if(!sa)
	  ev=index(tmp,"_");
	if(ev<length(tmp)) {
	  c=substr(tmp,ev+1,1);
	  if((c>="a"&&c<="z")||(c>="A"&&c<="Z"))
	    ev=0;
	}
	if(ev) {
	  sv=ev-1;
	  c=substr(tmp,sv,1);
	  while((c>="a"&&c<="z")||(c>="A"&&c<="Z")) {
	    sv--;
	    c=substr(tmp,sv,1);
	  }
	  sv++;
	  if(sv==ev)
	    sv=0;
	}
	
	mf=index(tmp,"(");
	if(mf){
	  o=index(tmp,"operator");
	  if(o==0) {
	    ef=mf-1;
	    c=substr(tmp,ef,1);
	    while(c==" "||c=="\t") {
	      ef--;
	      c=substr(tmp,ef,1);
	    }
	    sf=ef-1;
	    c=substr(tmp,sf,1);
	    while(sf&&c!=" "&&c!="&"&&c!="*") {
	      sf--;
	      c=substr(tmp,sf,1);
	    }
	    sf++;
	  }else {
	    sf=o;	  
	    ef=sf+7;
	    c=substr(tmp,ef,1);
	    while(c!=" "&&c!="(") {
	      ef++;
	      c=substr(tmp,ef,1);
	      
	    }
	    ef--;
	  }
	}

	sp=0;
	if(index(tmp,"private ")||index(tmp,"private:")){
	  supressPrivate=1;
	  sp++;
	}
	if(index(tmp,"protected ")||index(tmp,"protected:")){
	  supressPrivate=0;
	  sp++;
	}
	if(index(tmp,"public ")||index(tmp,"public:") ){
	  supressPrivate=0;
	  sp++;
	}       
	tc=0;
	if(index(tmp,"template")==1||\
	   index(tmp,"class")==1||\
	   index(tmp,"\}")==1)
	  tc++;
	if(loop==0&&sp==0&&tc==0)
	  header = header "\>";
      }else if(loop==0&&longFunc)
	header=header "\>\>";

      if(sf==0&&sa==0&&sv==0&&se==0) {	
	if(longFunc&&index(tmp,")"))
	  longFunc=0;
	header = header tmp "\\\ \n";
	break;
      }else {
	preFix="";
	posFix="";
	if(sf&&!(sf&&sa&&sa<sf)){
          # function
	  sh=sf;
	  eh=ef;
	  supress=0;
	  preFix=moduleTex className "::";
	  shi=sf;
	  c=substr(tmp,sh,4);
	  if(c=="\~\/"){
	    shi=sf+4;
	    preFix=preFix "Dest";
	  }else {
	    c=substr(tmp,sh,1);
	    if(c=="_"){
	      preFix=preFix "?";
	      shi=sf+1;
	    }
	  }
	  if(substr(tmp,shi,4)==moduleCode)
	    shi+=4;
	  ehi=ef;
	  longFunc=1;
	  funcName=substr(tmp,sh,eh-sh+1);
	  if(funcName==lastFuncName){
	    posFix=overloadCounter;
	    overloadCounter++;
	  }else{
	    overloadCounter=1;
	    lastFuncName=funcName;
	  }
	}else if(se) {
	  preFix=moduleTex className "::";
	  sh=se;
	  eh=ee;
	  shi=se;
	  ehi=ee;
	}else if(sv) {
          # variable 
	  preFix=moduleTex className "::";
	  posFix="?";
	  sh=sv;
	  eh=ev;
	  shi=sv;
	  ehi=ev-1;
	} else {
	  preFix=moduleTex;
	  sh=sa;
	  eh=ea;
	  shi=sa+4;
	  ehi=ea;
	}
		
	if(supressPrivate+supress==0){
	  label=preFix substr(tmp,shi,ehi-shi+1) posFix;
	  header = header substr(tmp,1,sh-1) "\htmlref{" substr(tmp,sh,eh-sh+1) \
	    "}{" label  "}";
#	  print "#" label "#" >> "allRef";
	  tmp = substr(tmp,eh+1,length(tmp)-eh);
	}else{
	  header = header substr(tmp,1,eh);
	  tmp=substr(tmp,eh+1,length(tmp)-eh);
	}	    
	loop=1;
      }
    }    
  }
  else if (saveFunction) {
    if (Function == "") Function = $0;
    else                Function = Function "\n" $0;
  }
  else if (saveReturn)       Return       = Return "\n" $0;
  else if (saveArguments)    arguments    = arguments "\n" $0;
}


