@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: abacusroot.w,v 4.9 2003/08/05 13:55:11 elf Exp $ @>

@q m i ABA_ABACUSROOT @>

@ All member functions are defined in the file {\tt abacusroot.cc}.

@(abacusroot.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "abacusroot.h"
#else
#include "abacus/abacusroot.h"
#endif

#include <stdlib.h>

@q m v Destructor @>
@ The destructor is only implemented since it should be virtual
  function.
@q m e t @>
@(abacusroot.cc@>=
@q m b f @>
  ABA_ABACUSROOT::~ABA_ABACUSROOT()
@q m e f @>
  { }

@q m v exit @>
@ The function |exit()| terminates the program and returns |code|
     to the environment from which the program was called.
@q m e t @>

  We overload the function |exit()| that in a debugger a break point can be
  easily set within this function in order to investigate the
  error. We also observed that for some reason it can be impossible
  to set a break point within a template. Here this function |exit()|
  was quite helpful during the debugging process.

  Exception handling could substitute many calls to the function |exit()|.
  However, in version 2.6.3 of the GNU \CPLUSPLUS/ compiler only a prototypical
  implementation of exception handling is available. As soon as a
  the GNU compiler provides a stable implementation of exception handling
  we will use this technique in future releases of this software.

@q m b a @>
  \BeginArg
  \docarg{|code|}{The exit code given to the environment.}
  \EndArg
@q m e a @>

@(abacusroot.cc@>=
@q m b f @>
  void ABA_ABACUSROOT::exit(enum EXITCODES code) const
@q m e f @>
  {
#ifdef ABACUS_PARALLEL
#ifdef ABACUSSAFE
    // stop in debugger
    int *a = 0;
    *a = 0;
#endif
#endif
    ::exit(code);
  }

@q m f onOff @>
@ The function onOff() converts a boolean variable
  to the strings |"on"| and |"off"|.
@q m e t @>

@q m b r @>
  \BeginReturn
  \docarg{|"on"|}{If |value| is |true|,}
  \docarg{|"off"|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  \docarg{|value|}{The boolean variable being converted.}
  \EndArg
@q m e a @>

@(abacusroot.cc@>=
@q m b f @>
  const char *ABA_ABACUSROOT::onOff(bool value)
@q m e f @>
  {
    if (value) return "on";
    else       return "off";
  }

@q m f fracPart @>
@q m e t @>
@ The function |fracPart()|.

@q m b r @>
  \BeginReturn
  The absolute value of the fractional
  part of the value |x|. E.g., it holds |fracPart(2.33) == 0.33| and
  |fracPart(-1.77) == 0.77|.
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  The value of which the fractional part is computed.
  \EndArg
@q m e a @>

@(abacusroot.cc@>=
#ifdef ABACUS_SYS_POWERPLUS
extern "C" {
#include "/home/user/christof/abacus/include/math.h"
}
#else
#include <math.h>
#endif

@q m b f @>
  double ABA_ABACUSROOT::fracPart(double x) const
@q m e f @>
  {
    if (x >= 0.0) return x-floor(x);
    else          return ceil(x)-x;
  }


