@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: array.w,v 4.7 2003/08/05 13:55:11 elf Exp $ @>

@ The generation of external templates for the GNU-Compiler.
@(array.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "array.h"
#include "array.inc"
#else
#include "abacus/array.h"
#include "abacus/array.inc"
#endif

#ifdef ABACUS_TEMPLATES_EXPLICIT
#include "array.eti"
#endif


#ifdef ABACUS_PARALLEL


@ The templates of the message constructor and the |pack()| function have
  to be specialized for all array types which should be sent or received.

  The library currently implements the following template specializations:


@(array.cc@>=
@q m b f @>
  ABA_ARRAY<int>::ABA_ARRAY(const ABA_GLOBAL *glob, ABA_MESSAGE &msg)
@q m e f @>
    : @/
    glob_(glob)
  {
    msg.unpack(n_);
    a_ = new @[int[n_]@];
    msg.unpack(a_, msg.unpackInt());
  }

@q m b f @>
  ABA_ARRAY<double>::ABA_ARRAY(const ABA_GLOBAL *glob, ABA_MESSAGE &msg)
@q m e f @>
    : @/
    glob_(glob)
  {
    msg.unpack(n_);
    a_ = new @[double[n_]@];
    msg.unpack(a_, msg.unpackInt());
  }

@q m b f @>
  ABA_ARRAY<ABA_FSVARSTAT*>::ABA_ARRAY(const ABA_GLOBAL *glob, ABA_MESSAGE &msg)
@q m e f @>
    : @/
    glob_(glob)
  {
    msg.unpack(n_);
    a_ = new @[(ABA_FSVARSTAT*)[n_]@];
    int nPacked;
    msg.unpack(nPacked);
    for (int i = 0; i < nPacked; i++)
      a_[i] = new @[ABA_FSVARSTAT(glob, msg)@];
  }

@q m b f @>
  ABA_ARRAY<ABA_LPVARSTAT*>::ABA_ARRAY(const ABA_GLOBAL *glob, ABA_MESSAGE &msg)
@q m e f @>
    : @/
    glob_(glob)
  {
    msg.unpack(n_);
    a_ = new @[(ABA_LPVARSTAT*)[n_]@];
    int nPacked;
    msg.unpack(nPacked);
    for (int i = 0; i < nPacked; i++)
      a_[i] = new @[ABA_LPVARSTAT(glob, msg)@];
  }

@q m b f @>
  ABA_ARRAY<ABA_SLACKSTAT*>::ABA_ARRAY(const ABA_GLOBAL *glob, ABA_MESSAGE &msg)
@q m e f @>
    : @/
    glob_(glob)
  {
    msg.unpack(n_);
    a_ = new @[(ABA_SLACKSTAT*)[n_]@];
    int nPacked;
    msg.unpack(nPacked);
    for (int i = 0; i < nPacked; i++)
      a_[i] = new @[ABA_SLACKSTAT(glob, msg)@];
  }

@#
@#

@q m b f @>
  void ABA_ARRAY<int>::pack(ABA_MESSAGE &msg, int nPacked) const
@q m e f @>
  {
    msg.pack(n_);
    msg.pack(nPacked);
    msg.pack(a_, nPacked);
  }

@q m b f @>
  void ABA_ARRAY<double>::pack(ABA_MESSAGE &msg, int nPacked) const
@q m e f @>
  {
    msg.pack(n_);
    msg.pack(nPacked);
    msg.pack(a_, nPacked);
  }

@q m b f @>
  void ABA_ARRAY<ABA_FSVARSTAT*>::pack(ABA_MESSAGE &msg, int nPacked) const
@q m e f @>
  {
    msg.pack(n_);
    msg.pack(nPacked);
    for (int i = 0; i < nPacked; i++)
      a_[i]->pack(msg);
  }

@q m b f @>
  void ABA_ARRAY<ABA_LPVARSTAT*>::pack(ABA_MESSAGE &msg, int nPacked) const
@q m e f @>
  {
    msg.pack(n_);
    msg.pack(nPacked);
    for (int i = 0; i < nPacked; i++)
      a_[i]->pack(msg);
  }

@q m b f @>
  void ABA_ARRAY<ABA_SLACKSTAT*>::pack(ABA_MESSAGE &msg, int nPacked) const
@q m e f @>
  {
    msg.pack(n_);
    msg.pack(nPacked);
    for (int i = 0; i < nPacked; i++)
      a_[i]->pack(msg);
  }

#endif
