@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: cowtimer.w,v 4.8 2003/08/05 13:55:14 elf Exp $ @>

@q m i ABA_COWTIMER @>

@ The member functions are defined in the file {\tt cowtimer.cc}.

@(cowtimer.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "cowtimer.h"
#else
#include "abacus/cowtimer.h"
#endif

#ifdef ABACUS_COMPILER_VISUAL_CPP 
#include <time.h>
#else
#include <sys/times.h>
#include <limits.h>
#endif


@q m f Constructor @>
@ After the application of the constructor the timer is not running,
  i.e., to measure time it has to be started explicitly.
@q m e t @>

  We initialize base time with the current time, such that later we
  can convert the time to $1\over100$ seconds without arithmetic overflow.
  The function |time()| is defined in the standard \CEE/-library.

@q m b a @>
  \BeginArg
  \docarg{|glob|}{A pointer to a global object.}
  \EndArg
@q m e a @>

@(cowtimer.cc@>=
@q m b f @>
  ABA_COWTIMER::ABA_COWTIMER(ABA_GLOBAL *glob) 
@q m e f @>
  : @/
    ABA_TIMER(glob)
  {
#ifdef ABACUS_COMPILER_VISUAL_CPP 
    baseTime_ = (long)time(NULL);
#else
    struct tms now;
    baseTime_ = (long)times(&now);
#endif
  }

@q m f Constructor @>
@ This constructor initializes the total time of the timer.
  The timer is not running, too.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|glob|}{A pointer to a global object.}
  \docarg{|centiSeconds|}{The initial value of the timer in $1\over100$
                          seconds.}
  \EndArg
@q m e a @>

@(cowtimer.cc@>=
@q m b f @>
  ABA_COWTIMER::ABA_COWTIMER(ABA_GLOBAL *glob, long centiSeconds) 
@q m e f @>
  : @/
    ABA_TIMER(glob, centiSeconds)
  {
#ifdef ABACUS_COMPILER_VISUAL_CPP 
    baseTime_ = (long)time(NULL);
#else
    struct tms now;
    baseTime_ = (long)times(&now);
#endif
  }

@q m v Destructor @>
@q m e t @>
@ The destructor.

@(cowtimer.cc@>=
@q m b f @>
  ABA_COWTIMER::~ABA_COWTIMER()
@q m e f @>
  { }
  
@ The function  returns the wall clock time since the initialization
  of the timer in $1\over100$ seconds.
  This function redefines the pure virtual function of the base
  class |ABA_TIMER|.

  The function |theTime()| uses the function |times()|, which returns
  the elapsed real time in clock ticks.

  On POWERPLUS there is only one process per processor. Therefore the
  elapsed time equals the cpu time and is not measured explicitly.

@(cowtimer.cc@>=
  long ABA_COWTIMER::theTime() const
  {
#if defined ABACUS_SYS_SUNOS4 || ABACUS_SYS_POWERPLUS
    return 0;
#elif defined ABACUS_COMPILER_VISUAL_CPP
    return (long) (100.0*difftime(time(NULL), baseTime_));
#else
    struct tms now;
    return (long) times(&now) - baseTime_;
#endif
  }
