@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: fastset.w,v 4.7 2003/08/05 13:55:17 elf Exp $ @>

@q m i ABA_FASTSET @>

@ The member functions are implemented in the file {\tt fastset.cc}.

@(fastset.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "fastset.h"
#else
#include "abacus/fastset.h"
#endif

@q m f Constructor @>
@q m e t @>
@ The constructor.

  At the beginning each possible set receives the rank 0.
  
@q m b a @>
      \BeginArg
      \docarg{|glob|}{A pointer to the corresponding global object.}
      \docarg{|size|}{Only integers between 0 and |size-1| can be inserted
                     in the set.}
      \EndArg
@q m e a @>      

@(fastset.cc@>=
@q m b f @>
  ABA_FASTSET::ABA_FASTSET(ABA_GLOBAL *glob, int size) 
@q m e f @>
  : @/
   ABA_SET(glob, size), @/
   rank_(glob, size, 0)
   { }

@q m f unionSets @>
@ The function |unionSets()| unites the sets |x| and |y|.
  It differs from the function |unionSets()| of the base class |ABA_SET|
  such that the tree with smaller rank is attached to the one with larger
  rank. Therefore, |x| is no more guaranteed to be the representative of the
  joint set.
@q m e t @>

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If both sets have been disjoint before the function call,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  \docarg{|x|}{An element of the first set of the union operation.}
  \docarg{|y|}{An element in the second set of the union operation.}
  \EndArg
@q m e a @>

@(fastset.cc@>=
@q m b f @>
  bool ABA_FASTSET::unionSets(int x, int y)
@q m e f @>
  {
    int xParent = findSet(x);
    int yParent = findSet(y);

    if (xParent == yParent) return false;

    if (rank_[xParent] > rank_[yParent])
      parent_[yParent] = xParent;
    else {
      parent_[xParent] = yParent;
      if (rank_[xParent] == rank_[yParent])
        rank_[yParent]++;
    }
    return true;
  }

