@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: lpmastersoplex.w,v 4.4 2003/08/05 13:55:22 elf Exp $ @>

@q m i ABA_LPMASTERSOPLEX @>

@ The member functions are defined in the file {\tt lpmastersoplex.cc}.

@(lpmastersoplex.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "master.h"
#include "lpmastersoplex.h"
#else
#include "abacus/master.h"
#include "abacus/lpmastersoplex.h"
#endif


@q m f Constructor @>
@q m e t @>
@ The constructor.
@q m b a @>
  \BeginArg
     \docarg{|master|}{The master of the optimization.}
  \EndArg
@q m e a @>

@(lpmastersoplex.cc@>=
@q m b f @>
  ABA_LPMASTERSOPLEX::ABA_LPMASTERSOPLEX(ABA_MASTER *master)
@q m e f @>
    : @/
    ABA_LPMASTER(master), @/
    soPlexRowRep_(true)
{ }


@q m v initializeLpParameters @>
@ The function |initializeLpParameters()| initializes the LP solver
  specific Parameters.
@q m e t @>

@(lpmastersoplex.cc@>=
@q m b f @>
  void ABA_LPMASTERSOPLEX::initializeLpParameters()
@q m e f @>
  {
    const char* SoPlexRepresentation[]={"Row", "Column"};
    int index = master_->findParameter("SoPlexRepresentation", 2, SoPlexRepresentation);
    soPlexRowRep_ = (index==0?true:false);
  }


@q m v setDefaultLpParameters @>
@ The function |setDefaultLpParameters()| sets default values of the LP solver
  specific Parameters.
@q m e t @>

@(lpmastersoplex.cc@>=
@q m b f @>
  void ABA_LPMASTERSOPLEX::setDefaultLpParameters()
@q m e f @>
  {
    master_->insertParameter("SoPlexRepresentation", "Row");
  }


@q m v printLpParameters @>
@ The function printLpParameters()| prints the settings of the LP solver
  specific Parameters.
@q m e t @>

@(lpmastersoplex.cc@>=
@q m b f @>
  void ABA_LPMASTERSOPLEX::printLpParameters()
@q m e f @>
  {
    master_->out() << "  Soplex Representation                  : ";
    master_->out() << (soPlexRowRep_ ? "Row" : "Column") << endl;
  }


@q m v outputLpStatistics @>
@ The function outputLpStatistics()| prints LP solver
  specific Statistics.
@q m e t @>

@(lpmastersoplex.cc@>=
@q m b f @>
  void ABA_LPMASTERSOPLEX::outputLpStatistics()
@q m e f @>
  { }


@q m f soplexRowRep @>
@q m e t @>
@ The function |soplexRowRep()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{if the default Soplex basis representation {\tt ROW}.}
  \docarg{|false|}{if the default Soplex basis representation {\tt COLUMN}.}
  \EndReturn
@q m e r @>

@(lpmastersoplex.cc@>=
@q m b f @>
  bool ABA_LPMASTERSOPLEX::soplexRowRep() const
@q m e f @>
  {
    return soPlexRowRep_;
  }

@q m f soplexRowRep @>
@q m e t @>
@ This version of the function |soplexRowRep()| sets the default representation
  of the Soplex basis.

@q m b a @>
  \BeginArg
  \docarg{|rep|}{If |rep| is |true|, then the default Soplex basis representation
                 is {\tt ROW}, otherwise it is {\tt COLUMN}.}
  \EndArg
@q m e a @>

@(lpmastersoplex.cc@>=
@q m b f @>
  void ABA_LPMASTERSOPLEX::soplexRowRep(bool rep)
@q m e f @>
  {
    soPlexRowRep_ = rep;
  }

