@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: lpmasterxpress.w,v 4.7 2003/08/05 13:55:22 elf Exp $ @>

@q m i ABA_LPMASTERXPRESS @>

@ The member functions are defined in the file {\tt lpmasterxpress.cc}.

@(lpmasterxpress.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "master.h"
#include "lpmasterxpress.h"
#else
#include "abacus/master.h"
#include "abacus/lpmasterxpress.h"
#endif


@q m f Constructor @>
@q m e t @>
@ The constructor.
@q m b a @>
  \BeginArg
     \docarg{|master|}{The master of the optimization.}
  \EndArg
@q m e a @>

@(lpmasterxpress.cc@>=
@q m b f @>
  ABA_LPMASTERXPRESS::ABA_LPMASTERXPRESS(ABA_MASTER *master)
@q m e f @>
    : @/
    ABA_LPMASTER(master), @/
    xpressOutput_(true), @/
    xpressPresolve_(true), @/
    xpressPricing_(0), @/
    nXpressReinitializations_(0)
{ }


@q m v initializeLpParameters @>
@ The function |initializeLpParameters()| initializes the LP solver
  specific Parameters.
@q m e t @>

@(lpmasterxpress.cc@>=
@q m b f @>
  void ABA_LPMASTERXPRESS::initializeLpParameters()
@q m e f @>
  {
    master_->assignParameter(xpressOutput_, "XpressOutput");
    master_->assignParameter(xpressPresolve_, "XpressPresolve");
    master_->assignParameter(xpressPricing_, "XpressPricing", -1, 1);
  }


@q m v setDefaultLpParameters @>
@ The function |setDefaultLpParameters()| sets default values of the LP solver
  specific Parameters.
@q m e t @>

@(lpmasterxpress.cc@>=
@q m b f @>
  void ABA_LPMASTERXPRESS::setDefaultLpParameters()
@q m e f @>
  {
    master_->insertParameter("XpressOutput", "true");
    master_->insertParameter("XpressPresolve", "true");
    master_->insertParameter("XpressPricing", "0");
  }


@q m v printLpParameters @>
@ The function |printLpParameters()| prints the settings of the LP solver
  specific Parameters.
@q m e t @>

@(lpmasterxpress.cc@>=
@q m b f @>
  void ABA_LPMASTERXPRESS::printLpParameters()
@q m e f @>
  {
    master_->out() << "  Output of Xpress                       : ";
    master_->out() << onOff(xpressOutput_) << endl;
    master_->out() << "  Presolve of Xpress                     : ";
    master_->out() << onOff(xpressPresolve_) << endl;
    master_->out() << "  Pricing method of Xpress               : ";
    master_->out() << xpressPricing_ << endl;
  }


@q m v outputLpStatistics @>
@ The function |outputLpStatistics()| prints LP solver
  specific Statistics.
@q m e t @>

@(lpmasterxpress.cc@>=
@q m b f @>
  void ABA_LPMASTERXPRESS::outputLpStatistics()
@q m e f @>
  {
    const int w = 6;

    master_->out() << "  Number of Xpress Reinitializations: ";
    master_->out() << setWidth(w) <<  nXpressReinitializations_ << endl;
  }


@ The function |countXpressReinitialization()| increments the
  counter for the reinitializations of the LP-solver Xpress.

@(lpmasterxpress.cc@>=
  void ABA_LPMASTERXPRESS::countXpressReinitialization()
  {
    ++nXpressReinitializations_;
  }
