@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: lpvarstat.w,v 4.10 2003/08/05 13:55:23 elf Exp $ @>

@q m i ABA_LPVARSTAT @>

@ All member functions are defined in the file {\tt lpvarstat.cc}.

@(lpvarstat.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "lpvarstat.h"
#include "global.h"
#else
#include "abacus/lpvarstat.h"
#include "abacus/global.h"
#endif

#ifdef ABACUS_PARALLEL
#include "abacus/message.h"
#endif

@q m f Constructor @>
@ This constructor initializes the status as |Unknown|.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|glob|}{A pointer to the corresponding global object.}
  \EndArg
@q m e a @>

@q m b f @>
  ABA_LPVARSTAT::ABA_LPVARSTAT(ABA_GLOBAL *glob) 
@q m e f @>

@q m f Constructor @>
@ This constructor initializes the |ABA_LPVARSTAT|.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|glob|}{A pointer to the corresponding global object.}
  \docarg{|status|}{The initial status.}
  \EndArg
@q m e a @>
    
@q m b f @>
  ABA_LPVARSTAT::ABA_LPVARSTAT(ABA_GLOBAL *glob, STATUS status) 
@q m e f @>

@q m f Constructor @>
@ This constructor make a copy of |*lpVarStat|.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|lpVarStat|}{A copy of this object is made.}
  \EndArg
@q m e a @>

@q m b f @>
  ABA_LPVARSTAT::ABA_LPVARSTAT(ABA_LPVARSTAT *lpVarStat) 
@q m e f @>

@ @(lpvarstat.cc@>=
#ifdef ABACUS_PARALLEL

@q m f Constructor @>
@q m e t @>

@ The message constructor creates the |ABA_LPVARSTAT| from a message.
@q m e t @>

@q m b a @>
    \BeginArg
    \docarg{|glob|}{A pointer to a global object.}
    \docarg{|msg|}{The message from which the object is initialized.}
    \EndArg
@q m e a @>

@(lpvarstat.cc@>=
@q m b f @>
  ABA_LPVARSTAT::ABA_LPVARSTAT(const ABA_GLOBAL *glob, ABA_MESSAGE &msg)
@q m e f @>
    : @/
    glob_(glob)
  {
    status_ = (STATUS) msg.unpackInt();
  }


@q m f pack @>
@ The function |pack()| packs the data of the |ABA_LPVARSTAT| in a message.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|msg|}{The |ABA_MESSAGE| object in which the status is packed.}
  \EndArg
@q m e a @>

@(lpvarstat.cc@>=
@q m b f @>
  void ABA_LPVARSTAT::pack(ABA_MESSAGE &msg) const
@q m e f @>
  {
    msg.pack((int)status_);
  }

#endif


@q m f Output Operator @>
@ The output operator writes the |STATUS| to an output stream
  in the form {\tt AtLowerBound}, {\tt Basic}, {\tt AtUpper\-Bound},
  {\tt NonBasicFree}, {\tt Eliminated}, {\tt Unknown}.
@q m e t @>

@q m b r @>
  \BeginReturn
  A reference to the output stream.
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  \docarg{|out|}{The output stream.}
  \docarg{|rhs|}{The status being output.}
  \EndArg
@q m e a @>

@(lpvarstat.cc@>=
@q m b f @>
  ostream &operator<<(ostream& out, const ABA_LPVARSTAT &rhs)
@q m e f @>
  {
    switch (rhs.status_) {
      case ABA_LPVARSTAT::AtLowerBound:  out << "AtLowerBound";
                                     break;
      case ABA_LPVARSTAT::Basic:         out << "Basic";
                                     break;
      case ABA_LPVARSTAT::AtUpperBound:  out << "AtUpperBound";
                                     break;
      case ABA_LPVARSTAT::NonBasicFree:  out << "NonBasicFree";
                                     break;
      case ABA_LPVARSTAT::Eliminated:    out << "Eliminated";
                                     break;                          
      case ABA_LPVARSTAT::Unknown:       out << "Unknown";
                                     break;
      default:                       rhs.glob_->err() << "Unknown status" << endl;
                                     rhs.exit(rhs.Fatal);
    }
    return out;
  }

@q m f status @>
@q m e t @>
@ The function |status()|.

@q m b r @>
  \BeginReturn
  The LP-status.
  \EndReturn
@q m e r @>

@q m b f @>
  ABA_LPVARSTAT::STATUS ABA_LPVARSTAT::status() const
@q m e f @>

@q m f status @>
@ This version of |status()| sets the status.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|stat|}{The new LP-status.}
  \EndArg
@q m e a @>

@q m b f @>
  void ABA_LPVARSTAT::status(STATUS stat)
@q m e f @>

@q m f status @>
@ Another version of the function |status()| for setting the status.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|stat|}{The new LP-status.}
  \EndArg
@q m e a @>

@q m b f @>
  void ABA_LPVARSTAT::status(const ABA_LPVARSTAT *stat)
@q m e f @>
  
@q m f atBound @>
@q m e t @>
@ The function |atBound()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If the variable status is |AtUpperBound| or |AtLowerBound|,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_LPVARSTAT::atBound() const
@q m e f @>

@q m f basic @>
@q m e t @>
@ The function |basic()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If the status is |Basic|,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_LPVARSTAT::basic() const
@q m e f @>

