@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q by Max B\"ohm @>
@q $Id: message.w,v 4.5 2003/08/05 13:55:24 elf Exp $ @>

@q m i ABA_MESSAGE @>

@ The member functions are implemented in the file {\tt message.cc}.


@(message.cc@>=
#include "abacus/message.h"


@ Static helper functions to read/write data from/to the stream

@(message.cc@>=
int ABA_MESSAGE::readit(ABA_MESSAGE *msg, char *buf, int len)
{
  // receive and decode len1 (the length of the message)
  XDR xdr;
  int len1;
  char buf_len1[4];
  int r = msg->stream_.recv_n(buf_len1, 4, 0);
  if (r != 4) {
    ACE_ERROR((LM_ERROR, "%p\n", "Error in recv_n"));
    assert(0);
  }
  xdrmem_create(&xdr, buf_len1, 4, XDR_DECODE);
  xdr_int(&xdr, &len1);
  xdr_destroy(&xdr);

  assert(len1<=len);

  // receive len1 bytes of data
  r = msg->stream_.recv_n(buf, len1, 0);
  if (r != len1) {
    ACE_ERROR((LM_ERROR, "%p\n", "Error in recv_n"));
    assert(0);
  }

  return r;
}

@#
int ABA_MESSAGE::writeit(ABA_MESSAGE *msg, const char *buf, int len)
{
  // encode and send the length
  char buf_len[4];
  XDR  xdr;
  xdrmem_create(&xdr, buf_len, 4, XDR_ENCODE);
  xdr_int(&xdr, &len);
  xdr_destroy(&xdr);
  int r = msg->stream_.send_n(buf_len, 4, 0);
  if (r != 4) {
    ACE_ERROR((LM_ERROR, "%p\n", "Error in send_n"));
    assert(0);
  }

  // send the data
  r = msg->stream_.send_n(buf, len, 0);
  if (r != len) {
    ACE_ERROR((LM_ERROR, "%p\n", "Error in send_n"));
    assert(0);
  }

  return r;
}


@q m f Constructor @>
@q m e t @>
@ The constructor. A message buffer encapsulates a bidirectional communication
  stream. The underlaying |ACE\_SOCK\_Stream| has to be initialized later by
  using the member function |stream()|.
@q m e t @>

@(message.cc@>=
@q m b f @>
  ABA_MESSAGE::ABA_MESSAGE()
@q m e f @>
  : @/
    ABA_MESSAGEBASE( (int (*)(void *, char *, int))readit,
                     (int (*)(void *, char *, int))writeit )
  {
  }


@q m f Destructor @>
@q m e t @>
@ The destructor.
@q m e t @>

@(message.cc@>=
@q m b f @>
  ABA_MESSAGE::~ABA_MESSAGE()
@q m e f @>
  {
    stream_.close();
  }

