@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q by Max B\"ohm @>
@q $Id: mtserver.w,v 4.4 2003/08/05 13:55:24 elf Exp $ @>

@q m i ABA_MTSERVER @>

@ The member functions are defined in the file {\tt mtserver.cc}.

@(mtserver.cc@>=
#include "abacus/mtserver.h"
#include "abacus/parmaster.h"
#include "abacus/master.h"

#include <ace/SOCK_Stream.h>
#include <ace/INET_Addr.h>

@q m f Constructor @>
@q m e t @>
@ The constructor.
@q m b a @>
  \BeginArg
       \docarg{|master|}{A pointer to the master object.}
       \docarg{|port|}{The port number on which the server is listening.}
       \docarg{|nThreads|}{The number of threads.}
  \EndArg
@q m e a @>
  
@(mtserver.cc@>=
@q m b f @>
  ABA_MTSERVER::ABA_MTSERVER(ABA_MASTER *master, int port, int nThreads) 
@q m e f @>
    : @/
    master_(master), @/
    port_(port), @/
    nThreads_(nThreads)
  {
  }

@q m f Destructor @>
@q m e t @>  
@ The destructor.

@(mtserver.cc@>=
@q m b f @>
  ABA_MTSERVER::~ABA_MTSERVER()
@q m e f @>
  {
  }


@q m f open @>
@q m e t @>  
@ The definition of the |open| function of |ACE_Task|. This function begins
  listening for connections on |port_|. |nThreads_| new threads are started
  which all will all accept connections on this port.

@(mtserver.cc@>=
@q m b f @>
  int ABA_MTSERVER::open(void*)
@q m e f @>
  {
    ACE_INET_Addr addr(port_);

    if (acceptor_.open(addr, 1) == -1) {
      master_->err() << "ABA_MTSERVER::open(): listening on port " << port_
                     << " failed!" << endl;
      exit(Fatal);
    }

    activate(THR_NEW_LWP, nThreads_);

    return 0;
  }

@q m f svc @>
@q m e t @>  
@ The function |svc| is the entry point of all threads.

@(mtserver.cc@>=
@q m b f @>
  int ABA_MTSERVER::svc()
@q m e f @>
  {
    ACE_Time_Value timeout(1);
    while (ACE_Thread_Manager::instance()->testcancel(ACE_Thread::self())==0) {
      ABA_MESSAGE   msg;
      ACE_INET_Addr addr;
      int ret = acceptor_.accept(msg.stream(), &addr, &timeout);
      if (ret==0)
        if (!svcMessage(msg))
          break;
    }

    return 0;
  }

@q m v svcMessage @>
@q m e t @>  
@ The pure virtual function |svcMessage| has to be defined in a subclass.
  This function must receive the message and service the connection. When
  this function returns the connection will be closed.

@q m b f @>
  bool ABA\_MTSERVER::svcMessage(ABA\_MESSAGE\& msg)
@q m e f @>
