@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: numvar.w,v 4.11 2003/08/05 13:55:25 elf Exp $ @>

@q m i ABA_NUMVAR @>

@ All member functions are defined in the file {\tt numvar.cc}.

@(numvar.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "numvar.h"
#include "master.h"
#else
#include "abacus/numvar.h"
#include "abacus/master.h"
#endif

@q m f Constructor @>
@q m e t @>
@ The constructor.

@q m b a @>
     \BeginArg
     \docarg
      {|master|}
      {A pointer to the corresponding master of the optimization.}
     \docarg
       {|sub|}
       {A pointer to the subproblem associated with variable. This
        can also be the 0-pointer.
       }
     \docarg
      {|number|}
      {The number of the column associated with the variable.}      
     \docarg
      {|dynamic|}
      {If this argument is |true|, then the variable can also be
       removed again from the set of active variables after it is
       added once.}
     \docarg
       {|local|}
       {If this argument is |true|, then the variable is only locally
        valid, otherwise it is globally valid. As a locally valid variable
        is associated with a subproblem, |sub| must not be 0, if |local|
        is |true|.
       }
     \docarg
       {|obj|}
       {The objective function coefficient of the variable.}
     \docarg
       {|lBound|}
       {The lower bound of the variable.}
     \docarg
       {|uBound|}
       {The upper Bound of the variable.}
     \docarg
       {|type|}
       {The type of the variable.}
  \EndArg
@q m e a @>

@(numvar.cc@>=
@q m b f @>
  ABA_NUMVAR::ABA_NUMVAR(ABA_MASTER *master, 
                         const ABA_SUB *sub, 
                         int number, 
                         bool dynamic,
                         bool local, 
                         double obj,
                         double lBound, 
                         double uBound, 
                         ABA_VARTYPE::TYPE type) 
@q m e f @>
  : @/
    ABA_VARIABLE(master, sub, dynamic, local, obj, lBound, uBound, type), @/
    number_(number) 
  { }

@q m v Destructor @>
@q m e t @>
@ The destructor.

@(numvar.cc@>=
@q m b f @>
  ABA_NUMVAR::~ABA_NUMVAR()
@q m e f @>
  { }


#ifdef ABACUS_PARALLEL

@q m f Constructor @>
@ The message constructor creates the variable from an |ABA_MESSAGE|.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|msg|}{The |ABA_MESSAGE| object from which the variable is initialized.}
  \EndArg
@q m e a @>

@(numvar.cc@>=
@q m b f @>
  ABA_NUMVAR::ABA_NUMVAR(const ABA_MASTER *master, ABA_MESSAGE &msg)
@q m e f @>
  : @/
    ABA_VARIABLE(master, msg)
  {
    msg.unpack(number_);
  }

@q m f pack @>
@ The function |pack()| packs the data of the variable in an
  |ABA_MESSAGE| object.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|msg|}{The |ABA_MESSAGE| object in which the variable is packed.}
  \EndArg
@q m e a @>

@(numvar.cc@>=
@q m b f @>
  void ABA_NUMVAR::pack(ABA_MESSAGE &msg) const
@q m e f @>
  {
    ABA_VARIABLE::pack(msg);
    msg.pack(number_);
  }

@q m f classId @>
@ The function |classId()| returns an integer which identifies the class.

@q m b r @>
  \BeginReturn
  The class identification.
  \EndReturn
@q m e r @>

@(numvar.cc@>=
@q m b f @>
  int ABA_NUMVAR::classId() const
@q m e f @>
  {
    return NUMVAR_CLASSID;
  }

#endif


@q m f Output Operator @>
@ The output operator writes the number of the variable to an output stream.
@q m e t @>

@q m b r @>
  \BeginReturn
  A reference to the output stream.
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  \docarg{|out|}{The output stream.}
  \docarg{|rhs|}{The variable being output.}
  \EndArg
@q m e a @>

@(numvar.cc@>=
@q m b f @>
  ostream &operator<<(ostream &out, const ABA_NUMVAR &rhs)
@q m e f @>
  {
    return out << '(' << rhs.number_  << ')' << endl;
  }

@q m f number @>
@q m e t @>
@ The function |number()|.

@q m b r @>
  \BeginReturn
  The number of the variable.
  \EndReturn
@q m e r @>

@q m b f @>
  int ABA_NUMVAR::number () const
@q m e f @>


