@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: optsense.w,v 4.6 2003/08/05 13:55:25 elf Exp $ @>

@q m i ABA_OPTSENSE @>

@ All member functions are defined in the file {\tt optsense.cc}.

@(optsense.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "optsense.h"
#else
#include "abacus/optsense.h"
#endif

@q m f Constructor @>
@ The constructor initializes the optimization sense.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|s|}{The sense of the optimization. The default value is
               |Unknown|.}
  \EndArg
@q m e a @>

@q m b f @>
  ABA_OPTSENSE::ABA_OPTSENSE(SENSE s) 
@q m e f @>

@q m f Output Operator @>
@ The output operator writes the optimization sense on an output stream
   in the form {\tt maximize}, {\tt minimize}, or
  {\tt unknown}.
@q m e t @>

@q m b r @>
  \BeginReturn
  The output stream.
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  \docarg{|out|}{The output stream.}
  \docarg{|rhs|}{The sense being output.}
  \EndArg
@q m e a @>

@(optsense.cc@>=
@q m b f @>
  ostream &operator<<(ostream &out, const ABA_OPTSENSE &rhs)
@q m e f @>
  {
    switch (rhs.sense_) {
      case ABA_OPTSENSE::Min:     out << "minimize";
                              break;
      case ABA_OPTSENSE::Max:     out << "maximize";
                              break;
      case ABA_OPTSENSE::Unknown: out << "unknown";
                              break;
    }
    return out;
  }

@q m f sense @>    
@q m e t @>
@ The function |sense()|.

@q m b r @>
  \BeginReturn
  The sense of the optimization.
  \EndReturn
@q m e r @>

@q m b f @>
  ABA_OPTSENSE::SENSE ABA_OPTSENSE::sense() const
@q m e f @>
  
@q m f sense @>
@ This version of the function |sense()| sets the optimization sense.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|s|}{The new sense of the optimization.}
  \EndArg
@q m e a @>

@q m b f @>
  void ABA_OPTSENSE::sense(SENSE s)
@q m e f @>

@q m f min @>
@q m e t @>
@ The function |min()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If it is minimization problem,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_OPTSENSE::min() const
@q m e f @>

@q m f max @>
@q m e t @>
@ The function |max()|.


@q m b r @>
  \BeginReturn
  \docarg{|true|}{If it is maximization problem,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_OPTSENSE::max() const
@q m e f @>

@q m f unknown @>
@q m e t @>
@ The function |unknown()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If the optimization sense  is unknown,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_OPTSENSE::unknown() const
@q m e f @>

