@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q by Max B\"ohm @>
@q $Id: subserver.w,v 4.3 2003/08/05 13:55:30 elf Exp $ @>

@q m i ABA_SUBSERVER @>

@ The member functions are defined in the file {\tt subserver.cc}.

@(subserver.cc@>=
#include "abacus/subserver.h"
#include "abacus/master.h"
#include "abacus/parmaster.h"
#include "abacus/sub.h"
#include "abacus/opensub.h"
#include "abacus/debug.h"


@q m v svcMessage @>
@q m e t @>  
@ The function |svcMessage| receives a subproblem and solves it.

@(subserver.cc@>=
@q m b f @>
  bool ABA_SUBSERVER::svcMessage(ABA_MESSAGE& msg)
@q m e f @>
  {
    if (debug(DEBUG_SUBSERVER))
      master_->out() << "DEBUG_SUBSERVER: receiving a subproblem..." << endl;

    msg.receive();

    ABA_SUB* sub = master_->unpackSub(msg);

    master_->openSub()->insert(sub);

    if (debug(DEBUG_SUBSERVER)) {
      master_->out() << "DEBUG_SUBSERVER: subproblem ";
      master_->parmaster()->printId(sub->id());
      master_->out() << " received and inserted into openSub list." << endl;
    }

    return true;
  }
