@q ABACUS - A Branch And CUt System                                          @>
@q Copyright (C) 1995 - 2003                                                 @>
@q University of Cologne, Germany                                            @>
@q                                                                           @>
@q This library is free software; you can redistribute it and/or             @>
@q modify it under the terms of the GNU Lesser General Public                @>
@q License as published by the Free Software Foundation; either              @>
@q version 2.1 of the License, or (at your option) any later version.        @>
@q                                                                           @>
@q This library is distributed in the hope that it will be useful,           @>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of            @>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         @>
@q Lesser General Public License for more details.                           @>
@q                                                                           @>
@q You should have received a copy of the GNU Lesser General Public          @>
@q License along with this library; if not, write to the Free Software       @>
@q Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA @>

@q $Id: vartype.w,v 4.7 2003/08/05 13:55:32 elf Exp $ @>

@q m i ABA_VARTYPE @>

@ All member functions are defined in the file {\tt vartype.cc}.

@(vartype.cc@>=
#ifdef ABACUS_OLD_INCLUDE
#include "vartype.h"
#else
#include "abacus/vartype.h"
#endif

#ifdef ABACUS_PARALLEL
#include "abacus/message.h"
#endif

@q m f Constructor @>
@ The default constructor lets the type of the variable uninitialized.
@q m e t @>

@q m b f @>
  ABA_VARTYPE::ABA_VARTYPE() 
@q m e f @>

@q m f Constructor @>
@ This constructor initializes the variable type.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|t|}{The variable type.}
  \EndArg
@q m e a @>

@q m b f @>
  ABA_VARTYPE::ABA_VARTYPE(TYPE t) 
@q m e f @>

@ @(vartype.cc@>=
#ifdef ABACUS_PARALLEL

@q m f Constructor @>
@q m e t @>

@ The message constructor creates the type from an |ABA_MESSAGE|.
@q m e t @>

@q m b a @>
    \BeginArg
    \docarg{|msg|}{The message from which the type is initialized.}
    \EndArg
@q m e a @>

@(vartype.cc@>=
@q m b f @>
  ABA_VARTYPE::ABA_VARTYPE(ABA_MESSAGE &msg)
@q m e f @>
  {
    type_ = (TYPE) msg.unpackInt();
  }

@q m f pack @>
@ The function |pack()| packs the type in an |ABA_MESSAGE|.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|msg|}{The |ABA_MESSAGE| object in which the type is packed.}
  \EndArg
@q m e a @>

@(vartype.cc@>=
@q m b f @>
  void ABA_VARTYPE::pack(ABA_MESSAGE &msg) const
@q m e f @>
  {
    msg.pack((int)type_);
  }

#endif


@q m f Output Operator @>
@ The output operator writes the variable type to an output stream in
  the format {\tt Continuous}, {\tt Integer}, or {\tt Binary}.
@q m e t @>

@q m b r @>
  \BeginReturn
  A reference to the output stream.
  \EndReturn
@q m e r @>

@q m b a @>
  \BeginArg
  \docarg{|out|}{The output stream.}
  \docarg{|rhs|}{The variable type being output.}
  \EndArg
@q m e a @>

@(vartype.cc@>=
@q m b f @>
  ostream &operator<<(ostream &out, const ABA_VARTYPE &rhs)
@q m e f @>
  {
    switch (rhs.type_) {
      case ABA_VARTYPE::Continuous: out << "Continuous";
                                break;
      case ABA_VARTYPE::Integer: out << "Integer";
                             break;
      case ABA_VARTYPE::Binary: out << "Binary";
                            break;
    }
    return out;
  }

@q m f type @>
@q m e t @>
@ The function |type()|.

@q m b r @>
  \BeginReturn
  The type of the variable.
  \EndReturn
@q m e r @>

@q m b f @>
  ABA_VARTYPE::TYPE ABA_VARTYPE::type() const
@q m e f @>

@q m f type @>
@ This version of the function |type()| sets the variable type.
@q m e t @>

@q m b a @>
  \BeginArg
  \docarg{|t|}{The new type of the variable.}
  \EndArg
@q m e a @>

@q m b f @>
  void ABA_VARTYPE::type(TYPE t)
@q m e f @>
  
@q m f discrete @>
@q m e t @>
@ The function |discrete()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If the type of the variable is |Integer| or  |Binary|,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_VARTYPE::discrete() const
@q m e f @>

@q m f binary @>
@q m e t @>
@ The function |binary()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If the type of the variable |Binary|,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@q m b f @>
  bool ABA_VARTYPE::binary() const
@q m e f @>
  
@q m f integer @>
@q m e t @>
@ The function |integer()|.

@q m b r @>
  \BeginReturn
  \docarg{|true|}{If the type of the variable is |Integer|,}
  \docarg{|false|}{otherwise.}
  \EndReturn
@q m e r @>

@(vartype.cc@>=
@q m b f @>
  bool ABA_VARTYPE::integer() const
@q m e f @>
  {
    if (type_ == Integer) return true;
    else                  return false;
  }
